function PrintInertiasMCA(output,detailed);
%prints the descriptives in the 'output' generated by CAnalysis.m
%
% INPUT
%       output      The 'output' structure generated by CAnalysis.m
%       detailed    1 -> Prints all the details
%                   0 -> Prints the basic information
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


disp('-------------------------------------------------------------------------');
disp(' ');
disp('Assessment of dimensionality based on Principal inertias (eigenvalues)');
disp(' ');
disp('Principal inertias');
disp(' ');
PrintPrincipalInertias(output.eig); 
disp(' ');
buff=sprintf('Average explained variance: %6.1f%% (dimensions explaining less variance should be excluded from the map; equivalent to Kaiser''s One-eigenvalue rule in EFA)',output.aev);
disp(buff);
disp(' ');
disp(' ');
if isfield(output,'eig_adj'),
    disp('Adjusted principal inertias based on eigenvalues of Burt matrix');
    disp(' ');
    PrintPrincipalInertias(output.eig_adj);
    disp(' ');
    buff=sprintf('Average adjusted explained variance: %6.1f%% (dimensions explaining less variance should be excluded from the map; equivalent to Kaiser''s One-eigenvalue rule in EFA)',output.aev_adj);
    disp(buff);
    disp(' ');
    disp(' ');
end;

return;