function varargout = ReadLabels(varargin)
% READLABELS Application M-file for ReadLabels.fig
%    FIG = ITD launch itd GUI.
%    ReadLabels('callback_name', ...) invoke the named callback.

% Last Modified by GUIDE v2.5 16-May-2013 13:41:35

if nargin == 0  % LAUNCH GUI

	fig = openfig(mfilename,'reuse');

	% Generate a structure of handles to pass to callbacks, and store it. 
	handles = guihandles(fig);
    guidata(fig, handles);

	if nargout > 0
		varargout{1} = fig;
	end

    
elseif ischar(varargin{1}) % INVOKE NAMED SUBFUNCTION OR CALLBACK

	try
		if (nargout)
			[varargout{1:nargout}] = feval(varargin{:}); % FEVAL switchyard
		else
			feval(varargin{:}); % FEVAL switchyard
		end
	catch
		disp(lasterr);
	end

end

% --------------------------------------------------------------------
function varargout = name_Callback(h, eventdata, handles, varargin)

% --------------------------------------------------------------------
function varargout = file_Callback(h, eventdata, handles, varargin)

% --------------------------------------------------------------------
function varargout = ok_Callback(h, eventdata, handles, varargin)

    if isempty(get(handles.name,'string')),
        msgbox('Please, enter the name of the variable to be created', 'CAR: Correspondence analysis with rotations','error');
        return
    end;

    if isempty(get(handles.file,'string')),
        msgbox('Please, select the file to be read', 'CAR: Correspondence analysis with rotations','error');
        return
    end;
    
    %MAKE THE VARIABLE GLOBAL
    str1 = {'global id tmp '};
    str2 = get(handles.name,'string');
    str3 = {';'};
    str4 = char(strcat(str1,str2,str3));
    evalin('base',str4);
    
    try 
        %LOAD THE VARIABLE
       
        str1 = {'id=fopen('''};
        str2 = get(handles.file,'string');;
        str3 = {''');'};
        str4 = char(strcat(str1,str2,str3));
        evalin('base',str4);
        
        evalin('base','tmp = textscan(id,''%s'');');
        str4 = char(strcat(get(handles.name,'string'),' = tmp{1};'));
        evalin('base',str4);
        evalin('base','clear id tmp;');   
        
	catch
        str1 = {'clear id tmp;'};
        str2 = get(handles.name,'string');
        str3 = {';'};
        str4 = char(strcat(str1,str2,str3));
        evalin('base',str4);
        msgbox(lasterr,'CAR: Correspondence analysis with rotations','error');
        return
	end
    delete(gcf);
    car
    return;

% --------------------------------------------------------------------
function varargout = cancel_Callback(h, eventdata, handles, varargin)
    
    delete(gcf);
    car
    return;

% --------------------------------------------------------------------
function varargout = Browse_Callback(h, eventdata, handles, varargin)

   [filename, pathname] = uigetfile({'*.txt'; '*.dat'}, 'Pick a TXT file');
    if isequal(filename,0)|isequal(pathname,0)
        msgbox('File not found','CAR: Correspondence analysis with rotations','error');
    else
       set(handles.file,'string',[pathname, filename]);
    end
 


% --- Executes on mouse press over figure background.
function figure1_ButtonDownFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
